require 'check'
require 'listpd'
class CheckProducer < ListProducer
  set_erb('check.erb')
  self.field_name = Check::Item.field_name
  self.field_caption = {
    :todo => "",
    :person => "",
    :value => "o",
    :note => "`",
  }
  self.caption = 'o'
  def do_mail(context, params)
      todo_key, = params['todo']
      @todo_key = todo_key
      @mode = :mail
  end
  def do_sendmail(context, params)
      sendmail(context, params, @todo_key)
      @mode = :browse
  end
  def check(key, value, note)
    @list.edit(key, nil, nil, value, note)
  end
  def do_check(context, params)
    case @mode
    when :check
      key, = params['key']
      value, = params['value']
      note, = params['note']
      check(key, value, note)
      @mode = :browse
    else
      key, = params['key']
      @currkey = key
      @mode = :check
    end
  end
require 'thread'
  def initialize(session, todo)
    super(session, todo)
    @mutex = Mutex.new
  end
  def sendmail(context, params, todo_key)
@mutex.synchronize do
  @action = 'http://' +
    String(context.req_meta_vars['HTTP_HOST']) +
    String(context.req_script_name) +
    String(context.req_path_info)
  pool = @list.fetch_hash_all.select do |i|
    i[:todo] == todo_key
  end
  person = $app.person.fetch_hash_all
  person.each do |person_item|
    person_key = person_item[:key]
    item = pool.find do |i|
      i[:person] == person_key
    end
    item ||= @list.add(todo_key, person_key, '', '')
    mail = person_item[:mail]
    open("sendmail.log", "ab") do |f|
      f.print <<EOT
To: #{mail}

#{params['text']}
omF: #{href('check', {'key'=>item[:key]})}
EOT
    end
  end
end # synchronize
  end
end
